/* avbinio.cpp--source code for avbinio.dll */

#include <stdio.h>

FILE * OpenRead(char * path);
FILE * OpenWrite(char * path);
int ReadByte(FILE * stream);
int ReadInt16(FILE * stream);
int ReadInt32(FILE * stream);
int ReadFloat(FILE * stream);
int ReadDoubleAsFloat(FILE * stream);
int GetIntVal();
float GetFloatVal();
int WriteByte(FILE * stream, int val);
int WriteInt16(FILE * stream, int val);
int WriteInt32(FILE * stream, int val);
int WriteFloat(FILE * stream, float val);
int WriteFloatAsDouble(FILE * stream, float val);
int Close(FILE * stream);

int IntVal;
float FloatVal;

FILE * OpenRead(char * path)
{
   return fopen(path,"rb");
}

FILE * OpenWrite(char * path)
{
   return fopen(path,"wb");
}

int ReadByte(FILE * stream)
{
   unsigned char B[1];
   size_t f_read;
   if (stream == NULL)
      return -1;
   f_read = fread(B,sizeof(unsigned char),1,stream);
   if (ferror(stream))
      return -9;
   if (feof(stream))
      return -2;
   IntVal = (int) B[0];
   return 0;
}

int ReadInt16(FILE * stream)
{
   short B[1];
   size_t f_read;
   if (stream == NULL)
      return -1;
   f_read = fread(B,sizeof(short),1,stream);
   if (ferror(stream))
      return -9;
   if (feof(stream))
      return -2;
   IntVal = (int) B[0];
   return 0;
}

int ReadInt32(FILE * stream)
{
   int B[1];
   size_t f_read;
   if (stream == NULL)
      return -1;
   f_read = fread(B,sizeof(int),1,stream);
   if (ferror(stream))
      return -9;
   if (feof(stream))
      return -2;
   IntVal = B[0];
   return 0;
}

int ReadFloat(FILE * stream)
{
   float B[1];
   size_t f_read;
   if (stream == NULL)
      return -1;
   f_read = fread(B,sizeof(float),1,stream);
   if (ferror(stream))
      return -9;
   if (feof(stream))
      return -2;
   FloatVal = B[0];
   return 0;
}

int ReadDoubleAsFloat(FILE * stream)
{
   double B[1];
   size_t f_read;
   if (stream == NULL)
      return -1;
   f_read = fread(B,sizeof(double),1,stream);
   if (ferror(stream))
      return -9;
   if (feof(stream))
      return -2;
   FloatVal = (float) B[0];
   return 0;
}

int GetIntVal()
{
   return IntVal;
}

float GetFloatVal()
{
   return FloatVal;
}

int WriteByte(FILE * stream, int val)
{
   unsigned char B[1];
   B[0] = (unsigned char) val;
   size_t f_write;
   if (stream == NULL)
      return -1;
   f_write = fwrite(B,sizeof(unsigned char),1,stream);
   if (ferror(stream))
      return -9;
   return 0;
}

int WriteInt16(FILE * stream, int val)
{
   short B[1];
   B[0] = (short) val;
   size_t f_write;
   if (stream == NULL)
      return -1;
   f_write = fwrite(B,sizeof(short),1,stream);
   if (ferror(stream))
      return -9;
   return 0;
}

int WriteInt32(FILE * stream, int val)
{
   int B[1];
   B[0] = val;
   size_t f_write;
   if (stream == NULL)
      return -1;
   f_write = fwrite(B,sizeof(int),1,stream);
   if (ferror(stream))
      return -9;
   return 0;
}

int WriteFloat(FILE * stream, float val)
{
   float B[1];
   B[0] = val;
   size_t f_write;
   if (stream == NULL)
      return -1;
   f_write = fwrite(B,sizeof(float),1,stream);
   if (ferror(stream))
      return -9;
   return 0;
}

int WriteFloatAsDouble(FILE * stream, float val)
{
   double B[1];
   B[0] = (double) val;
   size_t f_write;
   if (stream == NULL)
      return -1;
   f_write = fwrite(B,sizeof(double),1,stream);
   if (ferror(stream))
      return -9;
   return 0;
}

int Close(FILE * stream)
{
   return fclose(stream);
}
